#ifndef _CAMERA_HAL3_COMMON_
#define _CAMERA_HAL3_COMMON_

#include <utils/Timers.h>

#define VIDEO_MAJOR         81
#define SUPPORT_EXIF        (1)

#ifdef HAL3_HWC_BUFFER
#else
#define CAMERA_GRALLOC_USAGE  GRALLOC_USAGE_HW_TEXTURE | \
                                                        GRALLOC_USAGE_HW_RENDER | \
                                                        GRALLOC_USAGE_SW_READ_OFTEN | \
                                                        GRALLOC_USAGE_SW_WRITE_OFTEN 
#endif

#ifdef RTD_284X
#define HAL_PIXEL_FORMAT HAL_PIXEL_FORMAT_YCRCB_420_SP
#endif

#ifdef RTD_285X
#define HAL_PIXEL_FORMAT HAL_PIXEL_FORMAT_YCRCB_420_SP
#endif

#ifdef RTD_285O
#define HAL_PIXEL_FORMAT HAL_PIXEL_FORMAT_YCRCB_420_SP
#endif

#ifdef RTD_287X
#define HAL_PIXEL_FORMAT HAL_PIXEL_FORMAT_YCBCR_420_888
#endif

#ifdef RTD_287O
#define HAL_PIXEL_FORMAT HAL_PIXEL_FORMAT_YCBCR_420_888
#endif


using namespace android;

namespace android {

typedef struct _JPEG_RST_INFO {
    uint8_t *vaddr;
    int size;           // buffer size
    int jpegSize;       // jpeg file real size
    int frameNumber;
    nsecs_t pts;
    bool mSuccess;
    int mHasJPEG;
    uint8_t *pThumbBuf;
    uint32_t thumbSize;
} JPEG_RST_INFO;

typedef struct _JPEG_SRC_BUF_INFO {
    int32_t w;
    int32_t h;
    int32_t size;
    void *vaddr;
    uint32_t phyAddr;
} JPEG_SRC_BUF_INFO;

typedef struct _JPEG_DST_BUF_INFO {
    // jpeg
    int32_t size;
    int32_t w;
    int32_t h;
    void *vaddr;
    uint32_t phyAddr;
    int32_t bytesused;

    // thumbnail
    uint32_t tw;
    uint32_t th;
    void *thumbVAddr;
    //int32_t thumbBufSize;
    int32_t thumbBufUsed;

} JPEG_DST_BUF_INFO;

};

#endif
